from Products.Archetypes.public import *
from Products.Archetypes.Marshall import PrimaryFieldMarshaller
from Products.CMFCore import CMFCorePermissions
from config import PROJECTNAME

#
schema = BaseSchema + Schema ((

    # we override the default title field with a new label + descr.
    StringField('title',
        required = 1,
        searchable = 1,
        widget = StringWidget(
            label = 'Release',
            description = 'The release name or version number',
        ),
    ),

    TextField('summary',
        required = 0,
        searchable = 1,
        widget = TextAreaWidget(
            label = 'Summary',
            description = 'A short summary / teaser about this release'
        ),
    ),

    TextField('notes',
        required = 0,
        searchable = 1,
        default_content_type = "text/html",
        default_output_type = "text/html",
        allowable_content_types = ("text/plain", "text/html", "text/structured"),
        widget = TextAreaWidget(
            label = 'Release notes',
            description = 'Release notes or other comments specific for this release'
        ),
    ),

    FileField('release',
        required = 1,
        searchable = 1,
        widget = FileWidget(
            label = 'File',
            description = 'File for the release',
        ),
    ),

))



class Release(BaseContent):

    schema = schema

    def getFilename(self):
        return self.release.filename

    # only allow in productFolder
    factory_type_information={
        'global_allow':0,
        }

    actions = ({
        'id': 'view',
        'name': 'View',
        'action': 'string:${object_url}/release_view',
        'permissions': (CMFCorePermissions.View,)
        },)

registerType(Release, PROJECTNAME)
