from cStringIO import StringIO
from zLOG import LOG, PROBLEM, DEBUG, ERROR
from Products.Archetypes.public import *
from Products.Archetypes.Marshall import PrimaryFieldMarshaller
from Products.CMFCore import CMFCorePermissions
import PIL.Image
from PIL.Image import NEAREST, BILINEAR, BICUBIC, ANTIALIAS
from config import *


# a release
schema = BaseSchema + Schema ((
  
    # we override the default title field with a new label + descr.
    StringField('title',
        required = 1,
        searchable = 1,
        widget = StringWidget(
            label = 'Title',
            description = 'Very short note or title',
        ),
    ),
    TextField('description',
        required = 0,
        searchable = 1,
        default_content_type = "text/html",
        default_output_type = "text/html",
        allowable_content_types = ("text/plain", "text/html", "text/structured"),
        widget = TextAreaWidget(
            label = 'Description',
            description = 'Short description of what is shown on the screenshot'
        ),
    ),
    StringField('version',
        index="FieldIndex:schema",
        widget = StringWidget(
            label = 'Version',
            description = 'The program version the screenshot was created with',
        ),
    ),
    ImageField('screenshot',
        required = 1,
        widget = ImageWidget(
            label = 'Screenshot',
            description = 'Please upload the screenshot as gif, jpeg or png',
        ),
        sizes={ 'preview' : (PREVIEWMAXWIDTH, PREVIEWMAXHEIGHHT),
                'medium' : (MEDIUMMAXWIDTH, MEDIUMMAXHEIGHT),
                'default' : (SHOWMAXWIDTH, SHOWMAXHEIGHT)}
    ),       
))


class Screenshot(BaseContent):

    schema = schema
    
    # only allow in Product Folder
    factory_type_information={
        'global_allow':0,
        }

    actions = ({
        'id': 'view',
        'name': 'View',
        'action': 'string:${object_url}/screenshot_view',
        'permissions': (CMFCorePermissions.View,)
        },)
                
              
        
registerType(Screenshot, PROJECTNAME)
